package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.HelpText;
import com.izouma.awesomeadmin.service.HelpTextService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/helpText")
@RequiresAuthentication
public class HelpTextController {

    @Autowired
    private HelpTextService helpTextService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(HelpText record) {
        List<HelpText> pp = helpTextService.getHelpTextList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getHelpText", method = RequestMethod.GET)
    @ResponseBody
    public Result getHelpText(@RequestParam(required = false, value = "id") String id) {
        HelpText data = helpTextService.getHelpTextById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(HelpText record) {
        HelpText data = helpTextService.getHelpText(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, HelpText record) {
        Map<String, Object> result = new HashMap<>();

        List<HelpText> pp =helpTextService.getHelpTextByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(HelpText record) {
        boolean num = helpTextService.createHelpText(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateHelpText(HelpText record) {
        boolean num = helpTextService.updateHelpText(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteHelpText(@RequestParam(required = true, value = "id") String id) {

        boolean num = helpTextService.deleteHelpText(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, HelpText record) throws Exception {

    List<HelpText> helpTexts = helpTextService.getHelpTextList(record);


        String sheetName = "help_text";
        String titleName = "帮助说明数据表";
        String fileName = "帮助说明表";
        int columnNumber = 10;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "名称" ,   "内容" ,   "备注" ,   "类型"  };
        String[][] dataList = new String[helpTexts.size()][10];

        for (int i = 0; i < helpTexts.size(); i++) {

                        dataList[i][0] = String.valueOf(helpTexts.get(i).getId());
                        dataList[i][1] = String.valueOf(helpTexts.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(helpTexts.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(helpTexts.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(helpTexts.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(helpTexts.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(helpTexts.get(i).getTitle());
                        dataList[i][7] = String.valueOf(helpTexts.get(i).getContent());
                        dataList[i][8] = String.valueOf(helpTexts.get(i).getRemark());
                        dataList[i][9] = String.valueOf(helpTexts.get(i).getTypeFlag());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

